
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class WalletsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const wallets = await db.wallets.create(
            {
                id: data.id || undefined,
        
        wallet_code: data.wallet_code
        ||
        null
            ,
            
        status: data.status
        ||
        null
            ,
            
        available_balance: data.available_balance
        ||
        null
            ,
            
        pending_balance: data.pending_balance
        ||
        null
            ,
            
        currency: data.currency
        ||
        null
            ,
            
        opened_at: data.opened_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await wallets.setOwner( data.owner || null, {
            transaction,
        });
        
        await wallets.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return wallets;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const walletsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                wallet_code: item.wallet_code
            ||
            null
            ,
            
                status: item.status
            ||
            null
            ,
            
                available_balance: item.available_balance
            ||
            null
            ,
            
                pending_balance: item.pending_balance
            ||
            null
            ,
            
                currency: item.currency
            ||
            null
            ,
            
                opened_at: item.opened_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const wallets = await db.wallets.bulkCreate(walletsData, { transaction });

        // For each item created, replace relation files
        

        return wallets;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const wallets = await db.wallets.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.wallet_code !== undefined) updatePayload.wallet_code = data.wallet_code;
        
        
        if (data.status !== undefined) updatePayload.status = data.status;
        
        
        if (data.available_balance !== undefined) updatePayload.available_balance = data.available_balance;
        
        
        if (data.pending_balance !== undefined) updatePayload.pending_balance = data.pending_balance;
        
        
        if (data.currency !== undefined) updatePayload.currency = data.currency;
        
        
        if (data.opened_at !== undefined) updatePayload.opened_at = data.opened_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await wallets.update(updatePayload, {transaction});

        
        
        if (data.owner !== undefined) {
            await wallets.setOwner(
              
              data.owner,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await wallets.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return wallets;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const wallets = await db.wallets.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of wallets) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of wallets) {
                await record.destroy({transaction});
            }
        });


        return wallets;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const wallets = await db.wallets.findByPk(id, options);

        await wallets.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await wallets.destroy({
            transaction
        });

        return wallets;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const wallets = await db.wallets.findOne(
            { where },
            { transaction },
        );

        if (!wallets) {
            return wallets;
        }

        const output = wallets.get({plain: true});

        
        
        
        
        
        
        
        
        output.wallet_transactions_wallet = await wallets.getWallet_transactions_wallet({
            transaction
        });
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.owner = await wallets.getOwner({
            transaction
        });
        
        
        output.organizations = await wallets.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'owner',
        
        where: filter.owner ? {
          [Op.or]: [
            { id: { [Op.in]: filter.owner.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.owner.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.wallet_code) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'wallets',
                        'wallet_code',
                        filter.wallet_code,
                    ),
                };
            }
            
            if (filter.currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'wallets',
                        'currency',
                        filter.currency,
                    ),
                };
            }
            

            
            

            
            if (filter.available_balanceRange) {
                const [start, end] = filter.available_balanceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    available_balance: {
                    ...where.available_balance,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    available_balance: {
                    ...where.available_balance,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.pending_balanceRange) {
                const [start, end] = filter.pending_balanceRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    pending_balance: {
                    ...where.pending_balance,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    pending_balance: {
                    ...where.pending_balance,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.opened_atRange) {
                const [start, end] = filter.opened_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    opened_at: {
                    ...where.opened_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    opened_at: {
                    ...where.opened_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.status) {
                where = {
                    ...where,
                status: filter.status,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.wallets.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'wallets',
                        'wallet_code',
                        query,
                    ),
                ],
            };
        }

        const records = await db.wallets.findAll({
            attributes: [ 'id', 'wallet_code' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['wallet_code', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.wallet_code,
        }));
    }

    
};

